#include <stdio.h>
#include <wfdb/wfdb.h>
#include <wfdb/ecgcodes.h>

char *trim_whitespace(char *str)
{
   size_t len = 0;
   char *frontp = str - 1;
   char *endp = NULL;

   if (str == NULL) return NULL;
   if (str[0] == '\0') return str;
   len = strlen(str);
   endp = str + len;
   while (isspace(*(++frontp)));
   while (isspace(*(--endp)) && endp != frontp);
   if (str + len - 1 != endp)
      *(endp + 1) = '\0';
   else if (frontp != str && endp == frontp)
      *str = '\0';
   endp = str;
   if (frontp != str) {
      while (*frontp) *endp++ = *frontp++;
      *endp = '\0';
   }
   return str;
}

main(argc, argv)
int argc;
char *argv[];
{
   char flag, aux[2], *record = NULL;
   int sig, nsig, sgmt;
   long i;
   WFDB_Anninfo a;
   WFDB_Annotation annot;
   WFDB_Siginfo *s;
   WFDB_Frequency freq;
   WFDB_Sample w, max, min, v[2000];


   if(argc < 2) {
      fprintf(stderr, "usage: %s record\n", argv[0]);
      exit(1);
   }

   record = argv[1];
   if ((nsig = isigopen(record, NULL, 0)) < 1) exit(2);
   if ((s = (WFDB_Siginfo *)malloc(nsig * sizeof(WFDB_Siginfo))) == NULL) {
      (void)fprintf(stderr, "insufficient memory\n");
      exit(2);
   }
   a.name = "noisebp"; a.stat = WFDB_WRITE;
   if ((nsig = wfdbinit(record, &a, 1, s, nsig)) < 1) exit(2);

   /* Identify the lowest-numbered ABP, ART, or BP signal */
   for (i = 0; i < nsig; i++)
      if (strcmp(trim_whitespace(s[i].desc), "ABP") == 0 ||
         strcmp(s[i].desc, "ART") == 0 ||
         strcmp(s[i].desc, "BP") == 0)
            break;
   if (i == nsig) {
      fprintf(stderr, "No ABP signal specified\n");
      exit(3);
   }
   sig = i;
   //printf("La señal esta en %d y su ganancia es %f\n", sig, s[sig].gain);

// Frecuencia de muestreo
   freq = sampfreq(argv[1]);

   sgmt = 2*freq; //printf("FREQ %f, sgmt = %d\n", freq, sgmt);

// Inicializamos la estructura de anotaciones. Todos los latidos se etiquetan como normales
   annot.anntyp = NOTE;
   annot.subtyp = 0;
   annot.chan = 0;
   annot.num = 0;
   aux[0] = 1;
   annot.aux = aux;

   i=0; flag=0;
   do {
      for(w=sample(sig,i),max=w,min=w;((i+1)%sgmt) && sample_valid()==1; i++) {
         w = sample(sig,i);
         if(w > max) max = w;
         if(w < min) min = w;
      }
      if(sample_valid()!=1) continue;
      i++;
      if((max-min) < 10*s[sig].gain && !flag) {
         flag = 1;
         //printf("comienzo %ld\n", i-sgmt);
         annot.time = i-sgmt;
         aux[1]='(';
         //printf("salida putann %d\n",putann(0, &annot));
         putann(0, &annot);
      }
      else if((max-min)>=10*s[sig].gain && flag) {
         flag = 0;
         //printf("final %ld\n", i-sgmt);
         annot.time = i-sgmt;
         aux[1]=')';
         putann(0, &annot);
      }
   } while(sample_valid()==1);
   wfdbquit();
}
