#include <stdio.h>
#include <wfdb/wfdb.h>
#include <wfdb/ecgmap.h>
#include "listas.h"

void longshell(long *a, int n)
{
   int i,j,inc;
   long v;

   inc=1;
   do {
      inc *= 3;
      inc++;
   } while (inc <= n);
   do {
      inc /= 3;
      for (i=inc;i<n;i++) {
         v=a[i];
         j=i;
         while (a[j-inc] > v) {
            a[j]=a[j-inc];
            j -= inc;
            if (j < inc) break;
         }
         a[j]=v;
      }
   } while (inc > 1);
}

void shortshell(short *a, int n)
{
   int i,j,inc;
   short v;

   inc=1;
   do {
      inc *= 3;
      inc++;
   } while (inc <= n);
   do {
      inc /= 3;
      for (i=inc;i<n;i++) {
         v=a[i];
         j=i;
         while (a[j-inc] > v) {
            a[j]=a[j-inc];
            j -= inc;
            if (j < inc) break;
         }
         a[j]=v;
      }
   } while (inc > 1);
}

long testSegmento(struct lista *pqrs, long nqrs, long *pgqrs, long ngqrs, long *pwabp, long nwabp, long principio, long fin, short moda)
{
   long i, j, k, sum, dif;

   i=0; j=0; sum=0;
   while(pgqrs[i]<fin) {
      if(pgqrs[i]>principio) j++;
      for(k=0;k<nwabp; k++)
         if(pwabp[k] > pgqrs[i]) break;
      if((pwabp[k] <= pgqrs[i]) || (pwabp[k] > fin)) return nqrs;
      sum += (pwabp[k] - pgqrs[i]);
      i++;
   }
   i=0; k=0;
   while(pwabp[i]<fin) {
      if(pwabp[i]>principio) k++;
      i++;
   }
   if(j && j==k) {
      dif = sum/j;
      if(0.5*moda<dif && 1.5*moda>dif) {
//         printf("Encontrado un segmento con %ld latidos entre %ld y %ld: dist = %ld\n", j, principio, fin, sum/j);
         i=0;
         while(pgqrs[i]<fin) {
            if(pgqrs[i]>principio) {
               insertaNodo(pqrs, pgqrs[i]);
               nqrs++;
            }
            i++;
         }
      }
   }
   return nqrs;
}

int latidoAdelantadoIncorrecto(long pos, short rrmed, long*pwabp, long nwabp)
{
   short rr;
   long i, j;
   i = 0;
   while(i<nwabp-1) {
      if(pwabp[i]<pos && pwabp[i+1]>=pos) break;
      i++;
   }
   rr = pwabp[i+1] - pwabp[i];
   if(rr > 0.85*rrmed && rr < 1.25*rrmed) return 1;
   if(i < 2)
      i=0;
   else
      i-=2;

   for(j=i; j<i+4; j++)
      if(abs(rrmed - (pwabp[j+1] - pwabp[j])) < 0.85*rrmed)
         return 0;
   return 1;
}

int latidoAdelantadoIncorrecto2(long pos, short rrmed, long*pwabp, long nwabp)
{
   short rr;
   long i, j;
   i = 0;
   while(i<nwabp-2) {
      if(pwabp[i]<pos && pwabp[i+1]>=pos) break;
      i++;
   }
   rr = pwabp[i+2] - pwabp[i+1];
   if(rr > 0.85*rrmed && rr < 1.25*rrmed) return 1;
   if(i < 2)
      i=0;
   else
      i-=2;

   for(j=i; j<i+4; j++)
      if(abs(rrmed - (pwabp[j+1] - pwabp[j])) < 0.85*rrmed)
         return 0;
   return 1;
}

main(argc, argv)
int argc;
char *argv[];
{
   WFDB_Anninfo a[4];
   WFDB_Annotation annot;
   WFDB_Frequency freq;
   char zero, flagrrant, flagrrpost, flagsegment;
   short moda, modasv, dif, ndif[500], buf2[9], buf3[7], nsum, tmp[3], rrmed, rrant, rrpost, refract;
   long i, j, k, ngqrs, nwabp, nqrs, nsv, *pgqrs, *pwabp, *psv, sum, buf1[10], principio, fin;
   long indgqrs, indwabp;
   long comienzo, final;
   struct lista *pqrs, *t, *ant, *sig;

   if(argc < 2) {
      fprintf(stderr, "usage: %s record\n", argv[0]);
      exit(1);
   }

   a[0].name = "gqrs"; a[0].stat = WFDB_READ;
   a[1].name = "wabp"; a[1].stat = WFDB_READ;
   a[2].name = "noisebp"; a[2].stat = WFDB_READ;
   a[3].name = "sv"; a[3].stat = WFDB_READ;
   a[4].name = "qrs"; a[4].stat = WFDB_WRITE;

   if(annopen(argv[1], a, 5) < 0)
      exit(2);

// Inicializamos la estructura de anotaciones. Todos los latidos se etiquetan como normales
   annot.anntyp = NORMAL;
   annot.subtyp = 0;
   annot.chan = 0;
   annot.num = 0;
   zero = 0;
   annot.aux = &zero;


// Frecuencia de muestreo
   freq = sampfreq(argv[1]);
   refract = 0.2*freq;

// Calculamos el numero de latidos en el fichero de anotaciones generado por gqrs
   ngqrs = 0;
   while(1) {
      if(getann(0, &annot) < 0)
         break;
      if(isqrs(annot.anntyp))
         ngqrs++;
   }

// Calculamos el numero de latidos en el fichero de anotaciones generado por wabp
   nwabp = 0;
   while(1) {
      if(getann(1, &annot) < 0)
         break;
      if(isqrs(annot.anntyp))
         nwabp++;
   }
//printf("Numero latidos en wabp = %ld\n", nwabp);

// Calculamos el numero de latidos en el fichero de anotaciones generado por analizaSV
   nsv = 0;
   while(1) {
      if(getann(3, &annot) < 0)
         break;
      if(isqrs(annot.anntyp))
         nsv++;
   }

// Volvemos al comienzo
   if(iannsettime(0) < 0)
      exit(1);

// Reservamos espacio para almacenar en memoria las posiciones de los latidos
   if(ngqrs)
      pgqrs = (long *)malloc(ngqrs*sizeof(long));
   if(nwabp)
      pwabp = (long *)malloc(nwabp*sizeof(long));
   if(nsv)
      psv = (long *)malloc(nsv*sizeof(long));

// Creamos una lista dinamica que contendra los latidos validos
   pqrs = crearLista();


// Cargamos en pgqrs[] la lista de latidos detectados por gqrs
   for(i=0; i<ngqrs; i++) {
      if(getann(0, &annot) < 0)
         exit(2);
      if(isqrs(annot.anntyp))
         pgqrs[i] = annot.time;
   }


// O no hay canal de presiones y sv o no hay detecciones en los mismos. Copiamos literalmente lo que proporciona
// el detector de latidos sobre el ECG y terminamos
   if(!nwabp && !nsv) {
      for(i=0; i< ngqrs; i++) {
         annot.time = pgqrs[i];
         putann(0, &annot);
      }
      wfdbquit();
      exit(0);
   }

// Cargamos en pwabp[] la lista de latidos detectados por wabp
   for(i=0; i<nwabp; i++) {
      if(getann(1, &annot) < 0)
         exit(3);
      if(isqrs(annot.anntyp))
         pwabp[i] = annot.time;
   }

/*   if(nwabp) {
      while(1) {
         if(getann(2, &annot) < 0) break;
         if(annot.aux[1] == '(') comienzo = annot.time;
         else break;
         if(getann(2, &annot) < 0) break;
         if(annot.aux[1] == ')') final = annot.time;
         else break;
         for(i=0; i<nwabp; i++) {
            if(pwabp[i] > comienzo && pwabp[i] < final) pwabp[i] = 0;
         }
      }

      longshell(pwabp, nwabp);

      while(!(*pwabp)) {
         pwabp++; nwabp--;
      }
   }*/

// Cargamos en psv[] la lista de latidos detectados por analizaSV
   for(i=0; i<nsv; i++) {
      if(getann(3, &annot) < 0)
         exit(4);
      if(isqrs(annot.anntyp))
         psv[i] = annot.time;
   }

// Inicializamos la estructura de anotaciones. Todos los latidos se etiquetan como normales
   annot.anntyp = NORMAL;
   annot.subtyp = 0;
   annot.chan = 0;
   annot.num = 0;
   zero = 0;
   annot.aux = &zero;

   nqrs = 0;

// ##### Dependencia con wabp
if(nwabp) {
// Contabilizamos las diferencias entre los latidos en pgqrs y los inmediatamente posteriores en pwabp
   for(i=0; i<500; i++)
      ndif[i] = 0;

   for(i=0; i<ngqrs; i++) {
      for(j=0; j<nwabp; j++) {
         if(pwabp[j] > pgqrs[i])
            break;
      }
      dif = pwabp[j] - pgqrs[i];
      if(dif<0) break;
      if(dif>499) continue;
      ndif[dif]++;
   }

// Calculamos la moda de dichas diferencias
   j=0;
   moda=0;
   for(i=0; i<500; i++)
      if(ndif[i] > j) {
         j = ndif[i];
         moda = i;
      }

// Aquellos latidos en pgqrs cuya diferencia temporal con los presentes en pwabp sea del orden de la moda son aceptados
//   nqrs=0;
   for(i=0; i<ngqrs; i++) {
      for(j=0; j<nwabp; j++) {
         if(pwabp[j] > pgqrs[i])
            break;
      }
      dif = pwabp[j] - pgqrs[i];
      if(dif<0) break;
      if(dif<moda*1.2 && dif > moda*0.8) {
         if(buscaNodoumbrales(pqrs, pgqrs[i]-refract, pgqrs[i]+refract)==NULL) {
            pqrs = insertaNodo(pqrs, pgqrs[i]);
            nqrs++;
         }
      }
   }
} //#### Fin dependencia con wabp

// #### Dependencia con SV
if(nsv) {
// Contabilizamos las diferencias entre los latidos en pgqrs y los inmediatamente posteriores en psv
   for(i=0; i<500; i++)
      ndif[i] = 0;

   for(i=0; i<ngqrs; i++) {
      for(j=0; j<nsv; j++) {
         if(psv[j] > pgqrs[i])
            break;
      }
      dif = psv[j] - pgqrs[i];
      if(dif<0) break;
      if(dif>499) continue;
      ndif[dif]++;
   }

// Calculamos la moda de dichas diferencias
   j=0;
   modasv=0;
   for(i=0; i<500; i++)
      if(ndif[i] > j) {
         j = ndif[i];
         modasv = i;
      }

// Aquellos latidos en pgqrs cuya diferencia temporal con los presentes en psv sea del orden de la moda son aceptados
//   nqrs=0;
   for(i=0; i<ngqrs; i++) {
      for(j=0; j<nsv; j++) {
         if(psv[j] > pgqrs[i])
            break;
      }
      dif = psv[j] - pgqrs[i];
      if(dif<0) break;
      if(dif<modasv*1.2 && dif > modasv*0.8) {
         if(buscaNodoumbrales(pqrs, pgqrs[i]-refract, pgqrs[i]+refract)==NULL) {
            pqrs = insertaNodo(pqrs, pgqrs[i]);
            nqrs++;
         }
      }
   }
} //#### Fin dependencia con SV

// No se ha incorporado ningun latido con correspondencia en el canal de presiones. No obstante, puede ser necesario
// incorporar latidos adicionales, debido a que los pulsos en presiones se corresponden con zonas de ruido en ECG

   if(!nqrs) {
      for(i=0; i< ngqrs; i++) {
//         annot.time = pgqrs[i];
//         putann(0, &annot);
         pqrs = insertaNodo(pqrs, pgqrs[i]);
         nqrs++;
      }
   }

// Hay que verificar que los latidos incorporados tienen un segmento con un ritmo constante

   for(i=0; i<ngqrs; i++) {
      t = buscaNodo(pqrs, pgqrs[i]);
      if(t==NULL) {
         ant=buscaNodoanterior(pqrs, pgqrs[i]);
         sig=buscaNodosiguiente(pqrs, pgqrs[i]);
         t = ant;
         if(t==NULL) t = sig;
         if(t!=NULL) {
            for(j=0; j<9; j++) {
               if(t->anterior == NULL) break;
               t = t->anterior;
            }
            for(j=0; j<10; j++) buf1[j] = 0;
            for(j=0; j<10; j++) {
               buf1[j] = t->time;
               t = t->siguiente;
               if(t==NULL) break;
            }
            for(j=0; j<9; j++)
               buf2[j] = buf1[j+1] - buf1[j];
            for(j=1; j<8; j++) {
               tmp[0] = buf2[j-1];
               tmp[1] = buf2[j];
               tmp[2] = buf2[j+1];
               shortshell(tmp, 3);
               buf3[j-1] = tmp[1];
            }
            sum = 0; nsum = 0;
            for(j=0; j<7; j++) {
               sum += buf3[j];
               if(buf3[j])
                  nsum++;
            }
            rrmed = sum/nsum;
            if(rrmed > 4*freq || rrmed < 0.2*freq) continue;
            if(ant==NULL)
               rrant = 0;
            else
               rrant = pgqrs[i] - ant->time;
            if(sig==NULL)
               rrpost = 0;
            else
               rrpost = sig->time - pgqrs[i];


            flagrrant = 0; flagrrpost = 0;
            if((rrant < 1.25*rrmed) && (rrant > 0.85*rrmed))
               flagrrant = 1;
            if((rrpost < 1.25*rrmed) && (rrpost > 0.85*rrmed))
               flagrrpost = 1;
            if(((rrpost+rrant) < 2.2*rrmed) && ((rrpost+rrant) > 1.8*rrmed)) {
               flagrrant = 1; flagrrpost = 1;
            }
            if(rrant<0.85*rrmed)
               if(latidoAdelantadoIncorrecto(pgqrs[i], rrmed, pwabp, nwabp))
                  flagrrant=0;
            if(!rrant) flagrrant = 1;
            if(!rrpost) flagrrpost = 1;
//            if(flagrrant & flagrrpost) {
if(flagrrant) {
               if(buscaNodoumbrales(pqrs, pgqrs[i]-refract, pgqrs[i]+refract)==NULL) {
                  pqrs = insertaNodo(pqrs, pgqrs[i]);
                  nqrs++;
               }
            }
         }
      }
   }




   for(i=ngqrs-1; i>=0; i--) {
      t = buscaNodo(pqrs, pgqrs[i]);
      if(t==NULL) {
         ant=buscaNodoanterior(pqrs, pgqrs[i]);
         sig=buscaNodosiguiente(pqrs, pgqrs[i]);
         t = sig;
         if(t==NULL) t = ant;
         if(t!=NULL) {
            for(j=0; j<9; j++) {
               if(t->siguiente == NULL) break;
               t = t->siguiente;
            }
            for(j=0; j<10; j++) buf1[j] = 0;
            for(j=0; j<10; j++) {
               buf1[j] = t->time;
               t = t->anterior;
               if(t==NULL) break;
            }
            for(j=0; j<9; j++)
               buf2[j] = buf1[j] - buf1[j+1];
            for(j=1; j<8; j++) {
               tmp[0] = buf2[j-1];
               tmp[1] = buf2[j];
               tmp[2] = buf2[j+1];
               shortshell(tmp, 3);
               buf3[j-1] = tmp[1];
            }
            sum = 0; nsum = 0;
            for(j=0; j<7; j++) {
               sum += buf3[j];
               if(buf3[j])
                  nsum++;
            }
            rrmed = sum/nsum;
            if(rrmed > 4*freq || rrmed < 0.2*freq) continue;
            if(ant==NULL)
               rrant = 0;
            else
               rrant = pgqrs[i] - ant->time;
            if(sig==NULL)
               rrpost = 0;
            else
               rrpost = sig->time - pgqrs[i];


            flagrrant = 0; flagrrpost = 0;
            if((rrant < 1.25*rrmed) && (rrant > 0.85*rrmed))
               flagrrant = 1;
            if((rrpost < 1.25*rrmed) && (rrpost > 0.85*rrmed))
               flagrrpost = 1;
            if(((rrpost+rrant) < 2.2*rrmed) && ((rrpost+rrant) > 1.8*rrmed)) {
               flagrrant = 1; flagrrpost = 1;
            }
            if(rrpost<0.85*rrmed)
               if(latidoAdelantadoIncorrecto2(pgqrs[i], rrmed, pwabp, nwabp))
                  flagrrant=0;
            if(!rrant) flagrrant = 1;
            if(!rrpost) flagrrpost = 1;
//            if(flagrrant & flagrrpost) {
if(flagrrpost) {
               if(buscaNodoumbrales(pqrs, pgqrs[i]-refract, pgqrs[i]+refract)==NULL) {
                  pqrs = insertaNodo(pqrs, pgqrs[i]);
                  nqrs++;
               }
            }
         }
      }
   }

   for(i=0; i<nwabp; i++) {
      t = buscaNodoumbrales(pqrs, pwabp[i]-moda*1.2, pwabp[i]-moda*0.8);
      if(t==NULL) {
         ant=buscaNodoanterior(pqrs, pwabp[i]-moda);
         sig=buscaNodosiguiente(pqrs, pwabp[i]-moda);
         t = ant;
         if(t==NULL) t = sig;
         if(t!=NULL) {
            for(j=0; j<9; j++) {
               if(t->anterior == NULL) break;
               t = t->anterior;
            }
            for(j=0; j<10; j++) buf1[j] = 0;
            for(j=0; j<10; j++) {
               buf1[j] = t->time;
               t = t->siguiente;
               if(t==NULL) break;
            }
            for(j=0; j<9; j++)
               buf2[j] = buf1[j+1] - buf1[j];
            for(j=1; j<8; j++) {
               tmp[0] = buf2[j-1];
               tmp[1] = buf2[j];
               tmp[2] = buf2[j+1];
               shortshell(tmp, 3);
               buf3[j-1] = tmp[1];
            }
            sum = 0; nsum = 0;
            for(j=0; j<7; j++) {
               sum += buf3[j];
               if(buf3[j])
                  nsum++;
            }
            rrmed = sum/nsum;
            if(rrmed > 4*freq || rrmed < 0.2*freq) continue;
            if(ant==NULL)
               rrant = 0;
            else
               rrant = pwabp[i] - moda - ant->time;
            if(sig==NULL)
               rrpost = 0;
            else
               rrpost = sig->time - pwabp[i] + moda;


            flagrrant = 0; flagrrpost = 0;
            if((rrant < 1.25*rrmed) && (rrant > 0.85*rrmed))
               flagrrant = 1;
            if((rrpost < 1.25*rrmed) && (rrpost > 0.85*rrmed))
               flagrrpost = 1;
            if(((rrpost+rrant) < 2.2*rrmed) && ((rrpost+rrant) > 1.8*rrmed)) {
               flagrrant = 1; flagrrpost = 1;
            }
            if(!rrant) flagrrant = 1;
            if(!rrpost) flagrrpost = 1;
//            if(flagrrant & flagrrpost) {
            if(flagrrant) {
               if(((pwabp[i]-moda)>=0)&&(buscaNodoumbrales(pqrs, pwabp[i]-moda-refract, pwabp[i]-moda+refract)==NULL)) {
                  pqrs = insertaNodo(pqrs, pwabp[i]-moda);
                  nqrs++;
               }
            }
         }
      }
   }


   for(i=nwabp-1; i>=0; i--) {
      t = buscaNodoumbrales(pqrs, pwabp[i]-moda*1.2, pwabp[i]-moda*0.8);
      if(t==NULL) {
         ant=buscaNodoanterior(pqrs, pwabp[i]-moda);
         sig=buscaNodosiguiente(pqrs, pwabp[i]-moda);
         t = sig;
         if(t==NULL) t = ant;
         if(t!=NULL) {
            for(j=0; j<9; j++) {
               if(t->siguiente == NULL) break;
               t = t->siguiente;
            }
            for(j=0; j<10; j++) buf1[j] = 0;
            for(j=0; j<10; j++) {
               buf1[j] = t->time;
               t = t->anterior;
               if(t==NULL) break;
            }
            for(j=0; j<9; j++)
               buf2[j] = buf1[j] - buf1[j+1];
            for(j=1; j<8; j++) {
               tmp[0] = buf2[j-1];
               tmp[1] = buf2[j];
               tmp[2] = buf2[j+1];
               shortshell(tmp, 3);
               buf3[j-1] = tmp[1];
            }
            sum = 0; nsum = 0;
            for(j=0; j<7; j++) {
               sum += buf3[j];
               if(buf3[j])
                  nsum++;
            }
            rrmed = sum/nsum;
            if(rrmed > 4*freq || rrmed < 0.2*freq) continue;
            if(ant==NULL)
               rrant = 0;
            else
               rrant = pwabp[i] - moda - ant->time;
            if(sig==NULL)
               rrpost = 0;
            else
               rrpost = sig->time - pwabp[i] + moda;


            flagrrant = 0; flagrrpost = 0;
            if((rrant < 1.25*rrmed) && (rrant > 0.85*rrmed))
               flagrrant = 1;
            if((rrpost < 1.25*rrmed) && (rrpost > 0.85*rrmed))
               flagrrpost = 1;
            if(((rrpost+rrant) < 2.2*rrmed) && ((rrpost+rrant) > 1.8*rrmed)) {
               flagrrant = 1; flagrrpost = 1;
            }
            if(!rrant) flagrrant = 1;
            if(!rrpost) flagrrpost = 1;
//            if(flagrrant & flagrrpost) {
            if(flagrrant) {
               if(((pwabp[i]-moda)>=0)&&(buscaNodoumbrales(pqrs, pwabp[i]-moda-refract, pwabp[i]-moda+refract)==NULL)) {
                  pqrs = insertaNodo(pqrs, pwabp[i]-moda);
                  nqrs++;
               }
            }
         }
      }
   }

   flagsegment = 0;
   indgqrs = 0; indwabp = 0;
   while(indgqrs<ngqrs && indwabp<nwabp) {
      if(pgqrs[indgqrs] < pwabp[indwabp]) {
         if((t=buscaNodoumbrales(pqrs, pgqrs[indgqrs]-refract, pgqrs[indgqrs]+refract))==NULL) {
            if(!flagsegment) {
               t = buscaNodoanterior(pqrs, pgqrs[indgqrs]);
               if(t!=NULL)
                  principio = t->time;
               else
                  principio = 0;
            }
            flagsegment = 1;
         }
         else if(flagsegment) {
            flagsegment = 0;
            fin = t->time; //printf("%ld %ld\n", principio, fin);
            nqrs = testSegmento(pqrs, nqrs, pgqrs, ngqrs, pwabp, nwabp, principio, fin, moda);
         }
         indgqrs++;
      }
      else {
         if((t=buscaNodoumbrales(pqrs, pwabp[indwabp]-1.2*moda-refract, pwabp[indwabp]-0.8*moda+refract))==NULL) {
            if(!flagsegment) {
               t = buscaNodoanterior(pqrs, pwabp[indwabp]-moda);
               if(t!=NULL)
                  principio = t->time;
               else
                  principio = 0;
            }
            flagsegment = 1;
         }
         else if(flagsegment) {
            flagsegment = 0;
            fin = t->time; //printf("%ld %ld\n", principio, fin);
            nqrs = testSegmento(pqrs, nqrs, pgqrs, ngqrs, pwabp, nwabp, principio, fin, moda);
         }
         indwabp++;
      }
   }






   for(i=0; i<nsv; i++) {
      t = buscaNodoumbrales(pqrs, psv[i]-modasv*1.2, psv[i]-modasv*0.8);
      if(t==NULL) {
         ant=buscaNodoanterior(pqrs, psv[i]-modasv);
         sig=buscaNodosiguiente(pqrs, psv[i]-modasv);
         t = ant;
         if(t==NULL) t = sig;
         if(t!=NULL) {
            for(j=0; j<9; j++) {
               if(t->anterior == NULL) break;
               t = t->anterior;
            }
            for(j=0; j<10; j++) buf1[j] = 0;
            for(j=0; j<10; j++) {
               buf1[j] = t->time;
               t = t->siguiente;
               if(t==NULL) break;
            }
            for(j=0; j<9; j++)
               buf2[j] = buf1[j+1] - buf1[j];
            for(j=1; j<8; j++) {
               tmp[0] = buf2[j-1];
               tmp[1] = buf2[j];
               tmp[2] = buf2[j+1];
               shortshell(tmp, 3);
               buf3[j-1] = tmp[1];
            }
            sum = 0; nsum = 0;
            for(j=0; j<7; j++) {
               sum += buf3[j];
               if(buf3[j])
                  nsum++;
            }
            rrmed = sum/nsum;
            if(rrmed > 4*freq || rrmed < 0.2*freq) continue;
            if(ant==NULL)
               rrant = 0;
            else
               rrant = psv[i] - modasv - ant->time;
            if(sig==NULL)
               rrpost = 0;
            else
               rrpost = sig->time - psv[i] + modasv;


            flagrrant = 0; flagrrpost = 0;
            if((rrant < 1.25*rrmed) && (rrant > 0.85*rrmed))
               flagrrant = 1;
            if((rrpost < 1.25*rrmed) && (rrpost > 0.85*rrmed))
               flagrrpost = 1;
            if(((rrpost+rrant) < 2.2*rrmed) && ((rrpost+rrant) > 1.8*rrmed)) {
               flagrrant = 1; flagrrpost = 1;
            }
            if(!rrant) flagrrant = 1;
            if(!rrpost) flagrrpost = 1;
//            if(flagrrant & flagrrpost) {
            if(flagrrant) {
               if(((psv[i]-modasv)>=0)&&(buscaNodoumbrales(pqrs, psv[i]-modasv-refract, psv[i]-modasv+refract)==NULL)) {
                  pqrs = insertaNodo(pqrs, psv[i]-modasv);
                  nqrs++;
               }
            }
         }
      }
   }

   for(i=nsv-1; i>=0; i--) {
      t = buscaNodoumbrales(pqrs, psv[i]-modasv*1.2, psv[i]-modasv*0.8);
      if(t==NULL) {
         ant=buscaNodoanterior(pqrs, psv[i]-modasv);
         sig=buscaNodosiguiente(pqrs, psv[i]-modasv);
         t = sig;
         if(t==NULL) t = ant;
         if(t!=NULL) {
            for(j=0; j<9; j++) {
               if(t->siguiente == NULL) break;
               t = t->siguiente;
            }
            for(j=0; j<10; j++) buf1[j] = 0;
            for(j=0; j<10; j++) {
               buf1[j] = t->time;
               t = t->anterior;
               if(t==NULL) break;
            }
            for(j=0; j<9; j++)
               buf2[j] = buf1[j] - buf1[j+1];
            for(j=1; j<8; j++) {
               tmp[0] = buf2[j-1];
               tmp[1] = buf2[j];
               tmp[2] = buf2[j+1];
               shortshell(tmp, 3);
               buf3[j-1] = tmp[1];
            }
            sum = 0; nsum = 0;
            for(j=0; j<7; j++) {
               sum += buf3[j];
               if(buf3[j])
                  nsum++;
            }
            rrmed = sum/nsum;
            if(rrmed > 4*freq || rrmed < 0.2*freq) continue;
            if(ant==NULL)
               rrant = 0;
            else
               rrant = psv[i] - modasv - ant->time;
            if(sig==NULL)
               rrpost = 0;
            else
               rrpost = sig->time - psv[i] + modasv;


            flagrrant = 0; flagrrpost = 0;
            if((rrant < 1.25*rrmed) && (rrant > 0.85*rrmed))
               flagrrant = 1;
            if((rrpost < 1.25*rrmed) && (rrpost > 0.85*rrmed))
               flagrrpost = 1;
            if(((rrpost+rrant) < 2.2*rrmed) && ((rrpost+rrant) > 1.8*rrmed)) {
               flagrrant = 1; flagrrpost = 1;
            }
            if(!rrant) flagrrant = 1;
            if(!rrpost) flagrrpost = 1;
//            if(flagrrant & flagrrpost) {
            if(flagrrant) {
               if(((psv[i]-modasv)>=0)&&(buscaNodoumbrales(pqrs, psv[i]-modasv-refract, psv[i]-modasv+refract)==NULL)) {
                  pqrs = insertaNodo(pqrs, psv[i]-modasv);
                  nqrs++;
               }
            }
         }
      }
   }

   t = pqrs;
   for(i=0; i<nqrs-1; i++) {
      if((t->siguiente)->time - t->time > 5*freq) {
         for(j=0; j< ngqrs; j++) {
            if((pgqrs[j] > t->time) && (pgqrs[j] < ((t->siguiente)->time))) {
                  pqrs = insertaNodo(pqrs, pgqrs[j]);
                  nqrs++;
            }
         }
      }
   }

   if(nwabp) {
      t = pqrs;
      for(i=0; i<nqrs-1; i++) {
         if((t->siguiente)->time - t->time > 5*freq) {
            for(j=0; j< nwabp; j++) {
               if((pwabp[j]-moda > t->time) && (pwabp[j]-moda < ((t->siguiente)->time))) {
                  if(buscaNodoumbrales(pqrs, pwabp[j] -moda - refract, pwabp[j] - moda + refract) == NULL) {
                     pqrs = insertaNodo(pqrs, pwabp[j] - moda);
                     nqrs++;
                  }
               }
            }
         }
      }
   }

   if(nsv) {
      t = pqrs;
      for(i=0; i<nqrs-1; i++) {
         if((t->siguiente)->time - t->time > 5*freq) {
            for(j=0; j< nsv; j++) {
               if((psv[j]-modasv > t->time) && (psv[j]-modasv < ((t->siguiente)->time))) {
                  if(buscaNodoumbrales(pqrs, psv[j] -modasv - refract, psv[j] - modasv + refract) == NULL) {
                     pqrs = insertaNodo(pqrs, psv[j] - modasv);
                     nqrs++;
                  }
               }
            }
         }
      }
   }


/*   for(i=0; i<nwabp-1; i++) {
      if((pwabp[i+1] - pwabp[i]) > 5*freq) {
         for(j=0; j<ngqrs; j++) {
            if((pgqrs[j] > pwabp[i]) && (pgqrs[j] < pwabp[i+1])) {
               if(buscaNodoumbrales(pqrs, pgqrs[j]-refract, pgqrs[j]+refract)==NULL) {
                  pqrs = insertaNodo(pqrs, pgqrs[j]);
                  nqrs++;
               }
            }
         }
      }
   }
*/

/*   t = pqrs;
   while(t!=NULL) {
      ant = t->anterior;
      sig = t->siguiente;
      if(sig==NULL) break;


      if(ant==NULL)
         ant=t;
      for(j=0; j<9; j++) {
         if(ant->anterior == NULL) break;
         ant = ant->anterior;
      }
      for(j=0; j<10; j++) buf1[j] = 0;
      for(j=0; j<10; j++) {
         buf1[j] = ant->time;
         ant = ant->siguiente;
         if(ant==NULL) break;
      }
      for(j=0; j<9; j++)
         buf2[j] = buf1[j+1] - buf1[j];
      for(j=1; j<8; j++) {
         tmp[0] = buf2[j-1];
         tmp[1] = buf2[j];
         tmp[2] = buf2[j+1];
         shortshell(tmp, 3);
         buf3[j-1] = tmp[1];
      }
      sum = 0; nsum = 0;
      for(j=0; j<7; j++) {
         sum += buf3[j];
         if(buf3[j])
            nsum++;
      }
      rrmed = sum/nsum;
      if(rrmed > 4*freq || rrmed < 0.2*freq) {
         t = t->siguiente;
         continue;
      }
      if((sig->time - t->time) > 2*rrmed) {
       //  insertaNodo(pqrs, t->time + rrmed);
       //  nqrs++;
         t = t->siguiente;
         printf("INSERTADO\n");
      }
      t = t->siguiente;
   }*/
/*   for(i=0; i<ngqrs; i++) {
      if(buscaNodo(pqrs, pgqrs[i])==NULL) {
         flagsegment = 1;
         t = buscaNodoanterior
         if(i)
            principio = pgqrs[i-1];
         else
            principio = 0;
      }
      else if(flagsegment) {
         flagsegment = 0;
         fin = pgqrs[i];
         printf("%ld %ld\n", principio, fin);
      }
   }*/

/*   indgqrs = 0; indwabp = 0;
   nsec1=0; nsec2=0;
   while(indgqrs <ngqrs && indwabp<nwabp){
      if(pgqrs[indgqrs] < pwabp[indwabp]) {
         if(buscaNodo(pqrs, pgqrs[indgqrs])==NULL) {
            nsec1++;
         }
         else {
            if(nsec1==nsec2) printf("encontrada secuencia de %d latidos en %ld\n", nsec1, pgqrs[indgqrs]);
            nsec1=0;
            nsec2=0;
         }
         indgqrs++;
      }
      else {
         if(buscaNodoumbrales(pqrs, pwabp[indwabp]-moda*1.2, pwabp[i]-moda*0.8)==NULL) {
            nsec2++;
         }
         else {
            nsec1=0;
            nsec2=0;
         }
         indwabp++;
      }

   }
*/


// Empezamos al comienzo de la lista
   t=pqrs;


// Escribimos la totalidad de la lista
   for(i=0; i<nqrs; i++) {
      annot.time = t->time;//printf("%ld\n", t->time);
      putann(0, &annot);
      t = t->siguiente;
   }

// Cerramos los archivos y vaciamos la lista de memoria
   wfdbquit();
   borrarLista(pqrs);
}
